diff --git a/src/backend/utils/cache/inval.c b/src/backend/utils/cache/inval.c
index 92e48d5..8137119 100644
--- a/src/backend/utils/cache/inval.c
+++ b/src/backend/utils/cache/inval.c
@@ -86,10 +86,16 @@
  */
 #include "postgres.h"
 
+#include <signal.h>
+
+#include "access/transam.h"
 #include "access/twophase_rmgr.h"
 #include "access/xact.h"
 #include "catalog/catalog.h"
 #include "miscadmin.h"
+#include "storage/lmgr.h"
+#include "storage/procarray.h"
+#include "storage/proc.h"
 #include "storage/sinval.h"
 #include "storage/smgr.h"
 #include "utils/inval.h"
@@ -155,6 +161,14 @@ typedef struct TransInvalidationInfo
 
 static TransInvalidationInfo *transInvalInfo = NULL;
 
+static SharedInvalidationMessage *SharedInvalidMessagesArray;
+static int 					numSharedInvalidMessagesArray;
+static int 					maxSharedInvalidMessagesArray;
+
+static List *RecoveryLockList;
+static MemoryContext	RelationLockContext;
+
+
 /*
  * Dynamically-registered callback functions.  Current implementation
  * assumes there won't be very many of these at once; could improve if needed.
@@ -741,6 +755,8 @@ AtStart_Inval(void)
 		MemoryContextAllocZero(TopTransactionContext,
 							   sizeof(TransInvalidationInfo));
 	transInvalInfo->my_level = GetCurrentTransactionNestLevel();
+	SharedInvalidMessagesArray = NULL;
+	numSharedInvalidMessagesArray = 0;
 }
 
 /*
@@ -851,6 +867,126 @@ inval_twophase_postcommit(TransactionId xid, uint16 info,
 	}
 }
 
+static void
+MakeSharedInvalidMessagesArray(const SharedInvalidationMessage *msgs, int n)
+{
+	/*
+	 * Initialise array first time through in each commit
+	 */
+	if (SharedInvalidMessagesArray == NULL)
+	{
+		maxSharedInvalidMessagesArray = FIRSTCHUNKSIZE;
+		numSharedInvalidMessagesArray = 0;
+
+		/*
+		 * Although this is being palloc'd we don't actually free it directly.
+		 * We're so close to EOXact that we now we're going to lose it anyhow.
+		 */
+		SharedInvalidMessagesArray = palloc(maxSharedInvalidMessagesArray
+											* sizeof(SharedInvalidationMessage));
+	}
+
+	if ((numSharedInvalidMessagesArray + n) > maxSharedInvalidMessagesArray)
+	{
+		while ((numSharedInvalidMessagesArray + n) > maxSharedInvalidMessagesArray)
+			maxSharedInvalidMessagesArray *= 2;
+
+		SharedInvalidMessagesArray = repalloc(SharedInvalidMessagesArray,
+											maxSharedInvalidMessagesArray
+											* sizeof(SharedInvalidationMessage));
+	}
+
+	/*
+	 * Append the next chunk onto the array
+	 */
+	memcpy(SharedInvalidMessagesArray + numSharedInvalidMessagesArray,
+			msgs, n * sizeof(SharedInvalidationMessage));
+	numSharedInvalidMessagesArray += n;
+}
+
+/*
+ * xactGetCommittedInvalidationMessages() is executed by
+ * RecordTransactionCommit() to add invalidation messages onto the
+ * commit record. This applies only to commit message types, never to
+ * abort records. Must always run before AtEOXact_Inval(), since that
+ * removes the data we need to see.
+ *
+ * Remember that this runs before we have officially committed, so we
+ * must not do anything here to change what might occur *if* we should
+ * fail between here and the actual commit.
+ *
+ * Note that transactional validation does *not* write a invalidation
+ * WAL message using XLOG_RELATION_INVAL messages. Those are only used
+ * by non-transactional invalidation. see comments in
+ * EndNonTransactionalInvalidation().
+ *
+ * see also xact_redo_commit() and xact_desc_commit()
+ */
+int
+xactGetCommittedInvalidationMessages(SharedInvalidationMessage **msgs,
+										bool *RelcacheInitFileInval)
+{
+	MemoryContext oldcontext;
+
+	/* Must be at top of stack */
+	Assert(transInvalInfo != NULL && transInvalInfo->parent == NULL);
+
+	/*
+	 * Relcache init file invalidation requires processing both before and
+	 * after we send the SI messages.  However, we need not do anything
+	 * unless we committed.
+	 */
+	if (transInvalInfo->RelcacheInitFileInval)
+		*RelcacheInitFileInval = true;
+	else
+		*RelcacheInitFileInval = false;
+
+	/*
+	 * Walk through TransInvalidationInfo to collect all the messages
+	 * into a single contiguous array of invalidation messages. It must
+	 * be contiguous so we can copy directly into WAL message. Maintain the
+	 * order that they would be processed in by AtEOXact_Inval(), to ensure
+	 * emulated behaviour in redo is as similar as possible to original.
+	 * We want the same bugs, if any, not new ones.
+	 */
+	oldcontext = MemoryContextSwitchTo(CurTransactionContext);
+
+	ProcessInvalidationMessagesMulti(&transInvalInfo->CurrentCmdInvalidMsgs,
+									 MakeSharedInvalidMessagesArray);
+	ProcessInvalidationMessagesMulti(&transInvalInfo->PriorCmdInvalidMsgs,
+									 MakeSharedInvalidMessagesArray);
+	MemoryContextSwitchTo(oldcontext);
+
+#ifdef STANDBY_INVAL_DEBUG
+	if (numSharedInvalidMessagesArray > 0)
+	{
+		int i;
+
+		elog(LOG, "numSharedInvalidMessagesArray = %d", numSharedInvalidMessagesArray);
+
+		Assert(SharedInvalidMessagesArray != NULL);
+
+		for (i = 0; i < numSharedInvalidMessagesArray; i++)
+		{
+			SharedInvalidationMessage *msg = SharedInvalidMessagesArray + i;
+
+			if (msg->id >= 0)
+				elog(LOG, "catcache id %d", msg->id);
+			else if (msg->id == SHAREDINVALRELCACHE_ID)
+				elog(LOG, "relcache id %d", msg->id);
+			else if (msg->id == SHAREDINVALSMGR_ID)
+				elog(LOG, "smgr cache id %d", msg->id);
+		}
+	}
+#endif
+
+	if (numSharedInvalidMessagesArray > 0)
+		Assert(SharedInvalidMessagesArray != NULL);
+
+	*msgs = SharedInvalidMessagesArray;
+
+	return numSharedInvalidMessagesArray;
+}
 
 /*
  * AtEOXact_Inval
@@ -1041,6 +1177,42 @@ BeginNonTransactionalInvalidation(void)
 	Assert(transInvalInfo->CurrentCmdInvalidMsgs.cclist == NULL);
 	Assert(transInvalInfo->CurrentCmdInvalidMsgs.rclist == NULL);
 	Assert(transInvalInfo->RelcacheInitFileInval == false);
+
+	SharedInvalidMessagesArray = NULL;
+	numSharedInvalidMessagesArray = 0;
+}
+
+/*
+ * General function to log the SharedInvalidMessagesArray. Only current
+ * caller is EndNonTransactionalInvalidation(), but that may change.
+ */
+static void
+LogSharedInvalidMessagesArray(void)
+{
+	XLogRecData		rdata[2];
+	xl_rel_inval	xlrec;
+
+	if (numSharedInvalidMessagesArray == 0)
+		return;
+
+	START_CRIT_SECTION();
+
+	xlrec.nmsgs = numSharedInvalidMessagesArray;
+
+	rdata[0].data = (char *) (&xlrec);
+	rdata[0].len = MinSizeOfRelationInval;
+	rdata[0].buffer = InvalidBuffer;
+
+	rdata[0].next = &(rdata[1]);
+	rdata[1].data = (char *) SharedInvalidMessagesArray;
+	rdata[1].len = numSharedInvalidMessagesArray *
+								sizeof(SharedInvalidationMessage);
+	rdata[1].buffer = InvalidBuffer;
+	rdata[1].next = NULL;
+
+	(void) XLogInsert(RM_RELATION_ID, XLOG_RELATION_INVAL, rdata);
+
+	END_CRIT_SECTION();
 }
 
 /*
@@ -1081,7 +1253,25 @@ EndNonTransactionalInvalidation(void)
 	ProcessInvalidationMessagesMulti(&transInvalInfo->CurrentCmdInvalidMsgs,
 									 SendSharedInvalidMessages);
 
+	/*
+	 * Write invalidation messages to WAL. This is not required for
+	 * recovery, it is only required for standby servers. It's fairly
+	 * low overhead so don't worry. This allows us to trigger inval
+	 * messages on the standby as soon as we see these records.
+	 * see relation_redo_inval()
+	 *
+	 * Note that transactional validation uses an array attached to
+	 * a WAL commit record, so these messages are rare.
+	 */
+	ProcessInvalidationMessagesMulti(&transInvalInfo->CurrentCmdInvalidMsgs,
+									 MakeSharedInvalidMessagesArray);
+	LogSharedInvalidMessagesArray();
+
 	/* Clean up and release memory */
+
+	/* XXXHS: Think some more on memory allocation and freeing.
+	 */
+
 	for (chunk = transInvalInfo->CurrentCmdInvalidMsgs.cclist;
 		 chunk != NULL;
 		 chunk = next)
@@ -1235,3 +1425,439 @@ CacheRegisterRelcacheCallback(RelcacheCallbackFunction func,
 
 	++relcache_callback_count;
 }
+
+/*
+ * -----------------------------------------------------
+ * 		Standby wait timers and backend cancel logic
+ * -----------------------------------------------------
+ */
+
+static void
+InitStandbyDelayTimers(int *currentDelay_ms, int *standbyWait_ms)
+{
+	*currentDelay_ms = GetLatestReplicationDelay();
+
+	/*
+	 * If replication delay is enormously huge, just treat that as
+	 * zero and work up from there. This prevents us from acting
+	 * foolishly when replaying old log files.
+	 */
+	if (*currentDelay_ms < 0)
+		*currentDelay_ms = 0;
+
+#define STANDBY_INITIAL_WAIT_MS  1
+	*standbyWait_ms = STANDBY_INITIAL_WAIT_MS;
+}
+
+/*
+ * Standby wait logic for ResolveRecoveryConflictWithVirtualXIDs.
+ * We wait here for a while then return. If we decide we can't wait any
+ * more then we return true, if we can wait some more return false.
+ */
+static bool
+WaitExceedsMaxStandbyDelay(int *currentDelay_ms, int *standbyWait_ms)
+{
+	int		maxStandbyDelay_ms = maxStandbyDelay * 1000;
+
+	/*
+	 * If the server is already further behind than we would
+	 * like then no need to wait or do more complex logic.
+	 * max_standby_delay = -1 means wait for ever, if necessary
+	 */
+	if (maxStandbyDelay >= 0 &&
+		*currentDelay_ms >= maxStandbyDelay_ms)
+		return true;
+
+	/*
+	 * Sleep, then do bookkeeping.
+	 */
+	pg_usleep(*standbyWait_ms * 1000L);
+	*currentDelay_ms += *standbyWait_ms;
+
+	/*
+	 * Progressively increase the sleep times.
+	 */
+	*standbyWait_ms *= 2;
+	if (*standbyWait_ms > 1000)
+		*standbyWait_ms = 1000;
+
+	/*
+	 * Re-test our exit criteria
+	 */
+	if (maxStandbyDelay >= 0 &&
+		*currentDelay_ms >= maxStandbyDelay_ms)
+		return true;
+
+	return false;
+}
+
+/*
+ * This is the main executioner for any query backend that conflicts with
+ * recovery processing. Judgement has already been passed on it within
+ * a specific rmgr. Here we just issue the orders to the procs. The procs
+ * then throw the required error as instructed.
+ *
+ * We may ask for a specific cancel_mode, typically ERROR or FATAL.
+ *
+ * If we want an ERROR, we may defer that until the buffer manager
+ * sees a recently changed block. If we want this we must specify a
+ * valid conflict_lsn.
+ */
+void
+ResolveRecoveryConflictWithVirtualXIDs(VirtualTransactionId *waitlist,
+										char *reason, int cancel_mode,
+										XLogRecPtr conflict_lsn)
+{
+	int				standbyWait_ms;
+	int 			currentDelay_ms;
+	bool			logged;
+	int				wontDieWait = 1;
+
+	InitStandbyDelayTimers(&currentDelay_ms, &standbyWait_ms);
+	logged = false;
+
+    while (VirtualTransactionIdIsValid(*waitlist))
+    {
+		/*
+		 * log that we have been waiting for a while now...
+		 */
+		if (!logged && standbyWait_ms > 500)
+		{
+			elog(trace_recovery(DEBUG5),
+					"virtual transaction %u/%u is blocking %s",
+						waitlist->backendId,
+						waitlist->localTransactionId,
+						reason);
+			logged = true;
+		}
+
+		if (ConditionalVirtualXactLockTableWait(*waitlist))
+		{
+			waitlist++;
+			InitStandbyDelayTimers(&currentDelay_ms, &standbyWait_ms);
+			logged = false;
+		}
+		else if (WaitExceedsMaxStandbyDelay(&currentDelay_ms,
+											 &standbyWait_ms))
+		{
+			/*
+			 * Now find out who to throw out of the balloon.
+			 */
+			PGPROC *proc;
+
+			Assert(VirtualTransactionIdIsValid(*waitlist));
+			proc = VirtualTransactionIdGetProc(*waitlist);
+
+			/*
+			 * Kill the pid if it's still here. If not, that's what we wanted
+			 * so ignore any errors.
+			 */
+			if (proc)
+			{
+				/*
+				 * Startup process debug messages
+				 */
+				switch (cancel_mode)
+				{
+					case FATAL:
+						elog(trace_recovery(DEBUG1),
+							"recovery disconnects session with pid %d "
+							"because of conflict with %s (current delay %d secs)",
+								proc->pid,
+								reason,
+								currentDelay_ms / 1000);
+							break;
+					case ERROR:
+						elog(trace_recovery(DEBUG1),
+							"recovery cancels virtual transaction %u/%u pid %d "
+							"because of conflict with %s (current delay %d secs)",
+								waitlist->backendId,
+								waitlist->localTransactionId,
+								proc->pid,
+								reason,
+								currentDelay_ms / 1000);
+							break;
+					default:
+							/* No conflict pending, so fall through */
+							break;
+				}
+
+				Assert(proc->pid != 0);
+
+				/*
+				 * Issue orders for the proc to read next time it receives SIGINT
+				 */
+				proc->rconflicts.cancelMode = cancel_mode;
+
+				/*
+				 * Do we expect it to talk? No, Mr. Bond, we expect it to die.
+				 */
+				kill(proc->pid, SIGINT);
+
+				/* wait awhile for it to die */
+				pg_usleep(wontDieWait * 5000L);
+				wontDieWait *= 2;
+			}
+		}
+    }
+}
+
+/*
+ * -----------------------------------------------------
+ * Locking in Recovery Mode
+ * -----------------------------------------------------
+ *
+ * All locks are held by the Startup process using a single virtual
+ * transaction. This implementation is both simpler and in some senses,
+ * more correct. The locks held mean "some original transaction held
+ * this lock, so query access is not allowed at this time". So the Startup
+ * process is the proxy by which the original locks are implemented.
+ *
+ * We only keep track of AccessExclusiveLocks, which are only ever held by
+ * one transaction on one relation, and don't worry about lock queuing.
+ *
+ * We keep a single dynamically expandible list of locks in local memory,
+ * RelationLockList, so we can keep track of the various entried made by
+ * the Startup process's virtual xid in the shared lock table.
+ *
+ * List elements use type xl_rel_lock, since the WAL record type exactly
+ * matches the information that we need to keep track of.
+ *
+ * We use session locks rather than normal locks so we don't need
+ * ResourceOwners.
+ */
+
+/* called by relation_redo_lock() */
+static void
+RelationAddRecoveryLock(xl_rel_lock *lockRequest)
+{
+	xl_rel_lock 	*newlock;
+	LOCKTAG			locktag;
+	MemoryContext 	old_context;
+
+	elog(trace_recovery(DEBUG4),
+			"adding recovery lock: db %d rel %d",
+				lockRequest->dbOid, lockRequest->relOid);
+
+	/*
+	 * dbOid is InvalidOid when we are locking a shared relation.
+	 */
+	Assert(OidIsValid(lockRequest->relOid));
+
+	if (RelationLockContext == NULL)
+        RelationLockContext = AllocSetContextCreate(TopMemoryContext,
+														"RelationLocks",
+														ALLOCSET_DEFAULT_MINSIZE,
+														ALLOCSET_DEFAULT_INITSIZE,
+														ALLOCSET_DEFAULT_MAXSIZE);
+
+	old_context = MemoryContextSwitchTo(RelationLockContext);
+	newlock = palloc(sizeof(xl_rel_lock));
+	MemoryContextSwitchTo(old_context);
+
+	newlock->xid = lockRequest->xid;
+	newlock->dbOid = lockRequest->dbOid;
+	newlock->relOid = lockRequest->relOid;
+	RecoveryLockList = lappend(RecoveryLockList, newlock);
+
+	/*
+	 * Attempt to acquire the lock as requested.
+	 */
+	SET_LOCKTAG_RELATION(locktag, newlock->dbOid, newlock->relOid);
+
+	/*
+	 * Waiting for lock to clear or kill anyone in our way. Not a
+	 * completely foolproof way of getting the lock, but we cannot
+	 * afford to sit and wait for the lock indefinitely. This is
+	 * one reason why we reduced the strength of various locks in 8.4.
+	 */
+	while (LockAcquire(&locktag, AccessExclusiveLock, true, true)
+											== LOCKACQUIRE_NOT_AVAIL)
+	{
+		VirtualTransactionId *old_lockholders;
+
+		old_lockholders = GetLockConflicts(&locktag, AccessExclusiveLock);
+		ResolveRecoveryConflictWithVirtualXIDs(old_lockholders,
+												"exclusive lock",
+												ERROR,
+												InvalidXLogRecPtr);
+	}
+}
+
+static void
+RelationRemoveRecoveryLocks(TransactionId xid)
+{
+	ListCell   *l;
+	LOCKTAG		locktag;
+	List		*deletionList = NIL;
+
+	/*
+	 * Release all matching locks and identify list elements to remove
+	 */
+	foreach(l, RecoveryLockList)
+	{
+		xl_rel_lock *lock = (xl_rel_lock *) lfirst(l);
+
+		elog(trace_recovery(DEBUG4),
+				"releasing recovery lock: xid %u db %d rel %d",
+						lock->xid, lock->dbOid, lock->relOid);
+
+		if (!TransactionIdIsValid(xid) || lock->xid == xid)
+		{
+			SET_LOCKTAG_RELATION(locktag, lock->dbOid, lock->relOid);
+			if (!LockRelease(&locktag, AccessExclusiveLock, true))
+				elog(trace_recovery(LOG),
+					"RecoveryLockList contains entry for lock "
+					"no longer recorded by lock manager "
+					"xid %u database %d relation %d",
+						lock->xid, lock->dbOid, lock->relOid);
+			deletionList = lappend(deletionList, lock);
+		}
+	}
+
+	/*
+	 * Now remove the elements from RecoveryLockList. We can't navigate
+	 * the list at the same time as deleting multiple elements from it.
+	 */
+	foreach(l, deletionList)
+	{
+		xl_rel_lock *lock = (xl_rel_lock *) lfirst(l);
+
+		RecoveryLockList = list_delete_ptr(RecoveryLockList, lock);
+		pfree(lock);
+	}
+}
+
+/*
+ * Called during xact_commit_redo() and xact_commit_abort when InArchiveRecovery
+ * to remove any AccessExclusiveLocks requested by a transaction.
+ *
+ * Remove the lock tree, starting at xid down, from the RecoveryLockList.
+ */
+void
+RelationReleaseRecoveryLockTree(TransactionId xid, int nsubxids, TransactionId *subxids)
+{
+	int i;
+
+	RelationRemoveRecoveryLocks(xid);
+
+	for (i = 0; i < nsubxids; i++)
+		RelationRemoveRecoveryLocks(subxids[i]);
+}
+
+/*
+ * Called at end of recovery and when we see a shutdown checkpoint.
+ */
+void
+RelationClearRecoveryLocks(void)
+{
+	elog(trace_recovery(DEBUG2), "clearing recovery locks");
+	RelationRemoveRecoveryLocks(InvalidTransactionId);
+}
+
+/*
+ * --------------------------------------------------
+ * 		Recovery handling for Rmgr RM_RELATION_ID
+ * --------------------------------------------------
+ */
+
+/*
+ * Redo for relation lock messages
+ */
+static void
+relation_redo_lock(xl_rel_lock *xlrec)
+{
+	RelationAddRecoveryLock(xlrec);
+}
+
+/*
+ * Redo for relation invalidation messages
+ */
+static void
+relation_redo_inval(xl_rel_inval *xlrec)
+{
+	SharedInvalidationMessage *msgs = &(xlrec->msgs[0]);
+	int		nmsgs = xlrec->nmsgs;
+
+	Assert(nmsgs > 0);		/* else we should not have written a record */
+
+	/*
+	 * Smack them straight onto the queue and we're done. This is safe
+	 * because the only writer of these messages is non-transactional
+	 * invalidation.
+	 */
+	SendSharedInvalidMessages(msgs, nmsgs);
+}
+
+void
+relation_redo(XLogRecPtr lsn, XLogRecord *record)
+{
+	uint8		info = record->xl_info & ~XLR_INFO_MASK;
+
+	if (InArchiveRecovery)
+		(void) RecordKnownAssignedTransactionIds(lsn, record->xl_xid);
+
+	if (info == XLOG_RELATION_INVAL)
+	{
+		xl_rel_inval *xlrec = (xl_rel_inval *) XLogRecGetData(record);
+
+		relation_redo_inval(xlrec);
+	}
+	else if (info == XLOG_RELATION_LOCK)
+	{
+		xl_rel_lock *xlrec = (xl_rel_lock *) XLogRecGetData(record);
+
+		relation_redo_lock(xlrec);
+	}
+	else
+		elog(PANIC, "relation_redo: unknown op code %u", info);
+}
+
+static void
+relation_desc_inval(StringInfo buf, xl_rel_inval *xlrec)
+{
+	SharedInvalidationMessage *msgs = &(xlrec->msgs[0]);
+	int							nmsgs = xlrec->nmsgs;
+
+	appendStringInfo(buf, "nmsgs %d;", nmsgs);
+
+	if (nmsgs > 0)
+	{
+		int i;
+
+		for (i = 0; i < nmsgs; i++)
+		{
+			SharedInvalidationMessage *msg = msgs + i;
+
+			if (msg->id >= 0)
+				appendStringInfo(buf,  "catcache id %d", msg->id);
+			else if (msg->id == SHAREDINVALRELCACHE_ID)
+				appendStringInfo(buf,  "relcache ");
+			else if (msg->id == SHAREDINVALSMGR_ID)
+				appendStringInfo(buf,  "smgr ");
+		}
+	}
+}
+
+void
+relation_desc(StringInfo buf, uint8 xl_info, char *rec)
+{
+	uint8		info = xl_info & ~XLR_INFO_MASK;
+
+	if (info == XLOG_RELATION_INVAL)
+	{
+		xl_rel_inval *xlrec = (xl_rel_inval *) rec;
+
+		appendStringInfo(buf, "inval: ");
+		relation_desc_inval(buf, xlrec);
+	}
+	else if (info == XLOG_RELATION_LOCK)
+	{
+		xl_rel_lock *xlrec = (xl_rel_lock *) rec;
+
+		appendStringInfo(buf, "exclusive relation lock: xid %u db %d rel %d",
+								xlrec->xid, xlrec->dbOid, xlrec->relOid);
+	}
+	else
+		appendStringInfo(buf, "UNKNOWN");
+}
diff --git a/src/backend/utils/error/elog.c b/src/backend/utils/error/elog.c
index 9e25da1..4e9dd24 100644
--- a/src/backend/utils/error/elog.c
+++ b/src/backend/utils/error/elog.c
@@ -2703,3 +2703,20 @@ is_log_level_output(int elevel, int log_min_level)
 
 	return false;
 }
+
+/*
+ * If trace_recovery_messages is set to make this visible, then show as LOG,
+ * else display as whatever level is set. It may still be shown, but only
+ * if log_min_messages is set lower than trace_recovery_messages.
+ *
+ * Intention is to keep this for at least the whole of the 8.5 production
+ * release, so we can more easily diagnose production problems in the field.
+ */
+int
+trace_recovery(int trace_level)
+{
+	if (trace_level >= trace_recovery_messages)
+		return LOG;
+
+	return trace_level;
+}
diff --git a/src/backend/utils/init/flatfiles.c b/src/backend/utils/init/flatfiles.c
index 4a86809..222d6df 100644
--- a/src/backend/utils/init/flatfiles.c
+++ b/src/backend/utils/init/flatfiles.c
@@ -660,9 +660,10 @@ write_auth_file(Relation rel_authid, Relation rel_authmem)
 /*
  * This routine is called once during database startup, after completing
  * WAL replay if needed.  Its purpose is to sync the flat files with the
- * current state of the database tables.  This is particularly important
- * during PITR operation, since the flat files will come from the
- * base backup which may be far out of sync with the current state.
+ * current state of the database tables.
+ *
+ * In 8.5 we also run this during xact_redo_commit() if the transaction
+ * wrote a new database or auth flat file.
  *
  * In theory we could skip rebuilding the flat files if no WAL replay
  * occurred, but it seems best to just do it always.  We have to
@@ -695,8 +696,6 @@ BuildFlatFiles(bool database_only)
 	/*
 	 * We don't have any hope of running a real relcache, but we can use the
 	 * same fake-relcache facility that WAL replay uses.
-	 *
-	 * No locking is needed because no one else is alive yet.
 	 */
 	rel_db = CreateFakeRelcacheEntry(rnode);
 	write_database_file(rel_db);
@@ -723,6 +722,12 @@ BuildFlatFiles(bool database_only)
 
 	CurrentResourceOwner = NULL;
 	ResourceOwnerDelete(owner);
+
+	/*
+	 * Signal the postmaster to reload its caches.
+	 */
+	if (IsUnderPostmaster)
+		SendPostmasterSignal(PMSIGNAL_PASSWORD_CHANGE);
 }
 
 
@@ -811,14 +816,14 @@ AtEOXact_UpdateFlatFiles(bool isCommit)
 	/* Okay to write the files */
 	if (database_file_update_subid != InvalidSubTransactionId)
 	{
-		database_file_update_subid = InvalidSubTransactionId;
+		/* reset database_file_update_subid later during commit */
 		write_database_file(drel);
 		heap_close(drel, NoLock);
 	}
 
 	if (auth_file_update_subid != InvalidSubTransactionId)
 	{
-		auth_file_update_subid = InvalidSubTransactionId;
+		/* reset auth_file_update_subid later during commit */
 		write_auth_file(arel, mrel);
 		heap_close(arel, NoLock);
 		heap_close(mrel, NoLock);
@@ -838,6 +843,30 @@ AtEOXact_UpdateFlatFiles(bool isCommit)
 	ForceSyncCommit();
 }
 
+/*
+ * Exported to allow transaction commit to set flags to perform flat file
+ * update in redo. Reset per-transaction flags. For abort case they were
+ * already set during AtEOXact_UpdateFlatFiles().
+ */
+bool
+AtEOXact_Database_FlatFile_Update_Needed(void)
+{
+	bool result = TransactionIdIsValid(database_file_update_subid);
+
+	database_file_update_subid = InvalidSubTransactionId;
+
+	return result;
+}
+
+bool
+AtEOXact_Auth_FlatFile_Update_Needed(void)
+{
+	bool result = TransactionIdIsValid(auth_file_update_subid);
+
+	auth_file_update_subid = InvalidSubTransactionId;
+
+	return result;
+}
 
 /*
  * This routine is called during transaction prepare.
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 626343a..d70587a 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -403,7 +403,7 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 	 */
 	MyBackendId = InvalidBackendId;
 
-	SharedInvalBackendInit();
+	SharedInvalBackendInit(false);
 
 	if (MyBackendId > MaxBackends || MyBackendId <= 0)
 		elog(FATAL, "bad backend id: %d", MyBackendId);
@@ -418,10 +418,11 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 
 	/*
 	 * Initialize local process's access to XLOG.  In bootstrap case we may
-	 * skip this since StartupXLOG() was run instead.
+	 * skip this since StartupXLOG() was run instead. InitXLOGAccess() will
+	 * be called here if we are not in recovery processing mode.
 	 */
 	if (!bootstrap)
-		InitXLOGAccess();
+		(void) RecoveryInProgress();
 
 	/*
 	 * Initialize the relation cache and the system catalog caches.  Note that
@@ -455,9 +456,15 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 	 * Start a new transaction here before first access to db, and get a
 	 * snapshot.  We don't have a use for the snapshot itself, but we're
 	 * interested in the secondary effect that it sets RecentGlobalXmin.
+	 * If we are connecting during recovery, make sure the initial
+	 * transaction is read only and force all subsequent transactions
+	 * that way also.
 	 */
 	if (!bootstrap)
 	{
+		if (RecoveryInProgress())
+			SetConfigOption("default_transaction_read_only", "true",
+				PGC_POSTMASTER, PGC_S_OVERRIDE);
 		StartTransactionCommand();
 		(void) GetTransactionSnapshot();
 	}
@@ -540,7 +547,7 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 	 */
 	if (!bootstrap)
 		LockSharedObject(DatabaseRelationId, MyDatabaseId, 0,
-						 RowExclusiveLock);
+				(RecoveryInProgress() ? AccessShareLock : RowExclusiveLock));
 
 	/*
 	 * Recheck pg_database to make sure the target database hasn't gone away.
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index b7bf6e2..d13cc0f 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -116,6 +116,8 @@ extern char *temp_tablespaces;
 extern bool synchronize_seqscans;
 extern bool fullPageWrites;
 
+int	trace_recovery_messages = DEBUG1; /* XXXHS set to LOG for production */
+
 #ifdef TRACE_SORT
 extern bool trace_sort;
 #endif
@@ -2665,6 +2667,16 @@ static struct config_enum ConfigureNamesEnum[] =
 	},
 
 	{
+		{"trace_recovery_messages", PGC_SUSET, LOGGING_WHEN,
+			gettext_noop("Sets the message levels that are logged during recovery."),
+			gettext_noop("Each level includes all the levels that follow it. The later"
+						 " the level, the fewer messages are sent.")
+		},
+		&trace_recovery_messages,
+		DEBUG1, server_message_level_options, NULL, NULL
+	},
+
+	{
 		{"track_functions", PGC_SUSET, STATS_COLLECTOR,
 			gettext_noop("Collects function-level statistics on database activity."),
 			NULL
@@ -5470,8 +5482,19 @@ ExecSetVariableStmt(VariableSetStmt *stmt)
 						SetPGVariable("transaction_isolation",
 									  list_make1(item->arg), stmt->is_local);
 					else if (strcmp(item->defname, "transaction_read_only") == 0)
+					{
+						A_Const	   *con;
+
+						Assert(IsA(item->arg, A_Const));
+						con = (A_Const *) item->arg;
+						Assert(nodeTag(&con->val) == T_Integer);
+
+						if (!intVal(&con->val))
+							PreventCommandDuringRecovery();
+
 						SetPGVariable("transaction_read_only",
 									  list_make1(item->arg), stmt->is_local);
+					}
 					else
 						elog(ERROR, "unexpected SET TRANSACTION element: %s",
 							 item->defname);
@@ -5489,8 +5512,19 @@ ExecSetVariableStmt(VariableSetStmt *stmt)
 						SetPGVariable("default_transaction_isolation",
 									  list_make1(item->arg), stmt->is_local);
 					else if (strcmp(item->defname, "transaction_read_only") == 0)
+					{
+						A_Const	   *con;
+
+						Assert(IsA(item->arg, A_Const));
+						con = (A_Const *) item->arg;
+						Assert(nodeTag(&con->val) == T_Integer);
+
+						if (!intVal(&con->val))
+							PreventCommandDuringRecovery();
+
 						SetPGVariable("default_transaction_read_only",
 									  list_make1(item->arg), stmt->is_local);
+					}
 					else
 						elog(ERROR, "unexpected SET SESSION element: %s",
 							 item->defname);
diff --git a/src/backend/utils/time/snapmgr.c b/src/backend/utils/time/snapmgr.c
index 85065d3..b30e039 100644
--- a/src/backend/utils/time/snapmgr.c
+++ b/src/backend/utils/time/snapmgr.c
@@ -27,6 +27,7 @@
 
 #include "access/transam.h"
 #include "access/xact.h"
+#include "storage/bufmgr.h"
 #include "storage/proc.h"
 #include "storage/procarray.h"
 #include "utils/memutils.h"
@@ -433,7 +434,11 @@ static void
 SnapshotResetXmin(void)
 {
 	if (RegisteredSnapshots == 0 && ActiveSnapshot == NULL)
+	{
 		MyProc->xmin = InvalidTransactionId;
+		MyProc->rconflicts.nConflicts = 0;
+		/* Don't bother to reset other aspects of RecoveryConflictCache */
+	}
 }
 
 /*
diff --git a/src/backend/utils/time/tqual.c b/src/backend/utils/time/tqual.c
index a73db27..0281bb0 100644
--- a/src/backend/utils/time/tqual.c
+++ b/src/backend/utils/time/tqual.c
@@ -105,7 +105,7 @@ static inline void
 SetHintBits(HeapTupleHeader tuple, Buffer buffer,
 			uint16 infomask, TransactionId xid)
 {
-	if (TransactionIdIsValid(xid))
+	if (!RecoveryInProgress() && TransactionIdIsValid(xid))
 	{
 		/* NB: xid must be known committed here! */
 		XLogRecPtr	commitLSN = TransactionIdGetCommitLSN(xid);
@@ -1271,7 +1271,7 @@ XidInMVCCSnapshot(TransactionId xid, Snapshot snapshot)
 		for (j = 0; j < snapshot->subxcnt; j++)
 		{
 			if (TransactionIdEquals(xid, snapshot->subxip[j]))
-				return true;
+			return true;
 		}
 
 		/* not there, fall through to search xip[] */
diff --git a/src/include/access/heapam.h b/src/include/access/heapam.h
index ee17e4f..8e4accb 100644
--- a/src/include/access/heapam.h
+++ b/src/include/access/heapam.h
@@ -129,11 +129,13 @@ extern void heap2_desc(StringInfo buf, uint8 xl_info, char *rec);
 extern XLogRecPtr log_heap_move(Relation reln, Buffer oldbuf,
 			  ItemPointerData from,
 			  Buffer newbuf, HeapTuple newtup);
+extern XLogRecPtr log_heap_cleanup_info(RelFileNode rnode,
+			  TransactionId latestRemovedXid);
 extern XLogRecPtr log_heap_clean(Relation reln, Buffer buffer,
 			   OffsetNumber *redirected, int nredirected,
 			   OffsetNumber *nowdead, int ndead,
 			   OffsetNumber *nowunused, int nunused,
-			   bool redirect_move);
+			   TransactionId latestRemovedXid, bool redirect_move);
 extern XLogRecPtr log_heap_freeze(Relation reln, Buffer buffer,
 				TransactionId cutoff_xid,
 				OffsetNumber *offsets, int offcnt);
diff --git a/src/include/access/htup.h b/src/include/access/htup.h
index f271cbc..c846123 100644
--- a/src/include/access/htup.h
+++ b/src/include/access/htup.h
@@ -580,6 +580,7 @@ typedef HeapTupleData *HeapTuple;
 #define XLOG_HEAP2_FREEZE		0x00
 #define XLOG_HEAP2_CLEAN		0x10
 #define XLOG_HEAP2_CLEAN_MOVE	0x20
+#define XLOG_HEAP2_CLEANUP_INFO 0x30
 
 /*
  * All what we need to find changed tuple
@@ -668,6 +669,7 @@ typedef struct xl_heap_clean
 {
 	RelFileNode node;
 	BlockNumber block;
+	TransactionId	latestRemovedXid;
 	uint16		nredirected;
 	uint16		ndead;
 	/* OFFSET NUMBERS FOLLOW */
@@ -675,6 +677,19 @@ typedef struct xl_heap_clean
 
 #define SizeOfHeapClean (offsetof(xl_heap_clean, ndead) + sizeof(uint16))
 
+/*
+ * Cleanup_info is required in some cases during a lazy VACUUM.
+ * Used for reporting the results of HeapTupleHeaderAdvanceLatestRemovedXid()
+ * see vacuumlazy.c for full explanation
+ */
+typedef struct xl_heap_cleanup_info
+{
+	RelFileNode 	node;
+	TransactionId	latestRemovedXid;
+} xl_heap_cleanup_info;
+
+#define SizeOfHeapCleanupInfo (sizeof(xl_heap_cleanup_info))
+
 /* This is for replacing a page's contents in toto */
 /* NB: this is used for indexes as well as heaps */
 typedef struct xl_heap_newpage
@@ -718,6 +733,9 @@ typedef struct xl_heap_freeze
 
 #define SizeOfHeapFreeze (offsetof(xl_heap_freeze, cutoff_xid) + sizeof(TransactionId))
 
+extern void HeapTupleHeaderAdvanceLatestRemovedXid(HeapTupleHeader tuple,
+										TransactionId *latestRemovedXid);
+
 /* HeapTupleHeader functions implemented in utils/time/combocid.c */
 extern CommandId HeapTupleHeaderGetCmin(HeapTupleHeader tup);
 extern CommandId HeapTupleHeaderGetCmax(HeapTupleHeader tup);
